"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const enum_utils_1 = require("@react-jsonschema-form-utils/enum-utils");
const doOnChange = (onChange) => (e, checked) => onChange(checked);
const onCheckboxChangeHandler = (givenOnChange, value, schema, allValues, adds) => (e, checked) => {
    if (checked) {
        const finalValues = Array.isArray(allValues) ? [...allValues, value] : [value];
        givenOnChange(finalValues, adds);
    }
    else {
        const finalValues = allValues.filter((ev) => ev !== value);
        givenOnChange(finalValues);
    }
};
const onEnumChangeHandler = (givenOnChange, value, adds) => (e, checked) => {
    if (checked) {
        givenOnChange(value, adds);
    }
    else {
        givenOnChange('');
    }
};
exports.default = ({ onChange, schema = {}, value, }) => ({
    onChange: doOnChange(onChange),
    onEnumChange: (givenValue, adds) => onChange && onEnumChangeHandler(onChange, givenValue, adds),
    onGroupChange: (givenValue, adds) => onChange && onCheckboxChangeHandler(onChange, givenValue, schema, value, adds),
    label: schema.title,
    choices: enum_utils_1.valuesToOptions(enum_utils_1.isEnum(schema)),
});
//# sourceMappingURL=checkbox.props.js.map