"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const react_native_1 = require("react-native");
const react_native_paper_1 = require("react-native-paper");
const checkbox_props_1 = __importDefault(require("./checkbox.props"));
exports.default = (_a) => {
    var { value, type, onChange, schema = {}, options = {} } = _a, rest = __rest(_a, ["value", "type", "onChange", "schema", "options"]);
    const { onChange: givenOnChange, onGroupChange, onEnumChange, label, choices, } = checkbox_props_1.default({ onChange, schema, value });
    const GroupCheckbox = () => (react_1.default.createElement(react_native_1.View, { component: 'fieldset' },
        react_1.default.createElement(react_native_paper_1.Subheading, { component: 'legend' }, label),
        react_1.default.createElement(react_native_1.View, null, choices.map((o) => {
            const checked = typeof value === 'string' || Array.isArray(value) ?
                value === null || value === void 0 ? void 0 : value.includes(o.key)
                : typeof value === 'boolean' && value;
            return (react_1.default.createElement(react_native_paper_1.Checkbox, Object.assign({ checked: checked ? 'checked' : 'unchecked', onPress: onGroupChange(String(o.key), o.adds), disabled: o.disabled || false }, options)));
        }))));
    const CheckboxEnumComponent = () => (react_1.default.createElement(react_1.default.Fragment, null,
        (schema.title || schema.description) && (react_1.default.createElement(react_native_paper_1.Subheading, { component: 'legend' }, schema.title || schema.description)),
        choices.map((ev) => {
            const checked = String(value) === String(ev.key);
            return (react_1.default.createElement(react_native_paper_1.Checkbox, Object.assign({ checked: checked ? 'checked' : 'unchecked', onPress: onEnumChange(ev.key, ev.adds), disabled: ev.disabled || false }, options)));
        })));
    if (schema.type === 'boolean') {
        const stringToBoolean = !!value;
        return (react_1.default.createElement(react_1.default.Fragment, null,
            schema.description && (react_1.default.createElement(react_native_paper_1.Subheading, { component: 'legend' }, schema.description)),
            react_1.default.createElement(react_native_paper_1.Checkbox, Object.assign({ checked: typeof value === 'boolean' ? value : stringToBoolean, onChange: givenOnChange, disabled: options.disabled || false }, options))));
    }
    return schema.parsedArray ? (react_1.default.createElement(GroupCheckbox, null)) : react_1.default.createElement(CheckboxEnumComponent, null);
};
//# sourceMappingURL=index.js.map